<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTroubleConditionOutput ArrayType
 * @subpackage Arrays
 */
class ArrayOfTroubleConditionOutput extends AbstractStructArrayBase
{
    /**
     * The TroubleConditionOutput
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\TroubleConditionOutput[]
     */
    public $TroubleConditionOutput;
    /**
     * Constructor method for ArrayOfTroubleConditionOutput
     * @uses ArrayOfTroubleConditionOutput::setTroubleConditionOutput()
     * @param \CustomerManagement\StructType\TroubleConditionOutput[] $troubleConditionOutput
     */
    public function __construct(array $troubleConditionOutput = array())
    {
        $this
            ->setTroubleConditionOutput($troubleConditionOutput);
    }
    /**
     * Get TroubleConditionOutput value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\TroubleConditionOutput[]|null
     */
    public function getTroubleConditionOutput()
    {
        return isset($this->TroubleConditionOutput) ? $this->TroubleConditionOutput : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTroubleConditionOutput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTroubleConditionOutput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTroubleConditionOutputForArrayConstraintsFromSetTroubleConditionOutput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTroubleConditionOutputTroubleConditionOutputItem) {
            // validation for constraint: itemType
            if (!$arrayOfTroubleConditionOutputTroubleConditionOutputItem instanceof \CustomerManagement\StructType\TroubleConditionOutput) {
                $invalidValues[] = is_object($arrayOfTroubleConditionOutputTroubleConditionOutputItem) ? get_class($arrayOfTroubleConditionOutputTroubleConditionOutputItem) : sprintf('%s(%s)', gettype($arrayOfTroubleConditionOutputTroubleConditionOutputItem), var_export($arrayOfTroubleConditionOutputTroubleConditionOutputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TroubleConditionOutput property can only contain items of type \CustomerManagement\StructType\TroubleConditionOutput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TroubleConditionOutput value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\TroubleConditionOutput[] $troubleConditionOutput
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionOutput
     */
    public function setTroubleConditionOutput(array $troubleConditionOutput = array())
    {
        // validation for constraint: array
        if ('' !== ($troubleConditionOutputArrayErrorMessage = self::validateTroubleConditionOutputForArrayConstraintsFromSetTroubleConditionOutput($troubleConditionOutput))) {
            throw new \InvalidArgumentException($troubleConditionOutputArrayErrorMessage, __LINE__);
        }
        if (is_null($troubleConditionOutput) || (is_array($troubleConditionOutput) && empty($troubleConditionOutput))) {
            unset($this->TroubleConditionOutput);
        } else {
            $this->TroubleConditionOutput = $troubleConditionOutput;
        }
        return $this;
    }
    /**
     * Add item to TroubleConditionOutput value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\TroubleConditionOutput $item
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionOutput
     */
    public function addToTroubleConditionOutput(\CustomerManagement\StructType\TroubleConditionOutput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\TroubleConditionOutput) {
            throw new \InvalidArgumentException(sprintf('The TroubleConditionOutput property can only contain items of type \CustomerManagement\StructType\TroubleConditionOutput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TroubleConditionOutput[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\TroubleConditionOutput|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\TroubleConditionOutput|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\TroubleConditionOutput|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\TroubleConditionOutput|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\TroubleConditionOutput|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TroubleConditionOutput
     */
    public function getAttributeName()
    {
        return 'TroubleConditionOutput';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionOutput
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
